<template>

  <div class="contents">
    <div class="contents_wrap">
      <div class="top_wrap">
        <h3 class="title">배치 모니터링</h3>
        <p class="breadcrumb">모니터링 &gt; 배치 모니터링</p>
      </div>
      <div class="search_wrap">
        <div class="group">
          <h3>
            <label for="right" class="label">배치 ID  |  {{ this.batchId }}  </label>
          </h3>
        </div>
        <div class="group">
          <div class="input_box cal">
            <label for="right" class="label">조회기간</label>
            <div class="term">
              <span class="custom_input icon_date">
                <vuejs-datepicker
                    :language="ko"
                    :format="customFormatter"
                    :disabled-dates="disabledSDate"
                    v-model="startDate"
                    @selected="selectedStartDate(0)"
                    @closed="closeDate('start')"
                ></vuejs-datepicker>
              </span>~
              <span class="custom_input icon_date">
                <vuejs-datepicker
                    :language="ko"
                    :format="customFormatter"
                    :disabled-dates="disabledEDate"
                    v-model="endDate"
                    @selected="selectedEndDate(0)"
                    @closed="closeDate('end')"
                ></vuejs-datepicker>
              </span>
            </div>
          </div>
          <div class="select_box id">
            <label for="right" class="label">상태</label>
            <select name="" id="" v-model="sttusCd" @keyup.enter="search">
              <option value="" selected>전체</option>
              <option v-for="(option, i) in statType" v-bind:value="option.code" v-bind:key="i">
                {{ option.codeNm }}
              </option>
            </select>
          </div>
          <div>
            <button type="button" class="button grey" @click="search">조회</button>
          </div>
        </div>
        <div class="group" >
          <div class="input_box cal" v-show ="this.batchId != 'BATCH_016'">
            <label for="right" class="label">배치 수동 실행 </label>
            <div class="term">
              <span class="custom_input icon_date">
                  <vuejs-datepicker
                      :language="ko"
                      :format="customFormatter"
                      :disabled-dates="disabledSDate"
                      v-model="strDate"
                  ></vuejs-datepicker>
              </span>
            </div>
          </div>
          <button type="button" class="button grey" @click="runExecuteJob" v-show ="this.batchId != 'BATCH_016'">실행</button>
        </div>
      </div>

      <div class="info">
        <div class="count">총 <span>{{ totalItems.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',') }}</span>건
          <div class="select_box NumberSe">
            <select name="" id="" v-model="perPageCnt" @change="changePerPage()">
              <option v-for="option in options" v-bind:value="option.value" v-bind:key="option.value">{{
                  option.text
                }}
              </option>
            </select>
          </div>
        </div>
      </div>

      <div class="table">
        <custom-grid
            ref="table"
            :totalItems="'totalItems'"
            :url="grid.url"
            :columns="grid.columns"
            :pagePerRows="grid.pagePerRows"
            :pagination="grid.pagination"
            :noDataStr="grid.noDataStr"
        ></custom-grid>
      </div>
    </div>
  </div>
</template>

<script>
import customGrid from '@/components/CustomGrid';
import moment from 'moment';
import api from '@/service/api.js';
import sysMgtApi from '../service/sysMgtApi';

export default {
  name: 'batchDetail',
  data() {
    return {
      //paramBatchId : this.$route.params.batchId,
      //날짜 조회
      ko: vdp_translation_ko.js,
      periodDay: 7,
      sDateDiv: 'day',
      startDate: new Date(),
      endDate: new Date(),
      strDate: new Date(),

      totalCnt: '',

      pageType: 'CALC',

      batchId : this.$route.params.batchId,
      batchNm : this.$route.params.batchNm,

      //상태조회
      sttusCd: '',
      statType: [],

      perPageCnt: 50,
      options: [
        {text: '20', value: 20},
        {text: '50', value: 50},
        {text: '100', value: 100}
      ],
      totalItems: 0,
      grid: {
        url: '/api/v1/bo/sysMgt/batchDetail',
        pagePerRows: 20,
        pagination: true,
        header: [
          [
            {header: '배치ID', childNames: {}},
            {header: '배치명', childNames: {}},
          ]
        ],
        columns: [
          // {name: 'batchId', header:'배치ID', align:'center', width:'20%'},
          {name: 'stDt', header: '시작 일시', align: 'center', width: '12%'},
          {name: 'fnsDt', header: '종료 일시', align: 'center', width: '12%'},
          {name: 'sttusCd', header:'상태코드', align: 'center', width: '7%'},
          {name: 'errMsg', header:'메시지', align: 'left', width: '67%'},
        ],
        noDataStr: '검색 결과가 없습니다.',
        params: {
          batchId : '',
          sttusCd: '',
          startDt: '',
          endDt: '',
        }
      }
    };
  },  
  components: {
    customGrid: customGrid,
    vuejsDatepicker,
  },
  created(){
    this.setPeriodDay(0);
    this.setCodeData();
    // if(this.$route.params.batchId != null){
    //   this.$store.commit('dataStore/updateDataStore', this.$route.params.batchId);
    // } else {
    //   var batchId2 = this.$store.getters['dataStore/getDataStore'];
    //   this.batchId = batchId2;
    // }
  },
  destroyed() {
    // this.$store.commit('dataStore/updateDataStore', '');
    this.$store.commit('searchcondition/updateSearchCondition', {
      page: 1,
      perPage: 50,
      params: {
        startDt: '',
        endDt: ''
      }
    });
  },
  mounted(){
    let page = 1;
    // 페이지 정보 및 검색 조건
    const getCondition = this.$store.getters['searchcondition/getSearchCondition'];
    
    // store에 저장된 페이지 정보 및 검색 조건을 불러오기
    let isKeep = false;
    if (getCondition) {
      this.grid.pagePerRows = getCondition.perPage;
      this.grid.params = getCondition.params;
      page = getCondition.page;
      isKeep = true;
    }
    this.search(isKeep);
  },
  // beforeRouteLeave(to, from, next) {

  //   const getP = this.$refs.table.getPagination();
  //   this.$store.commit('searchcondition/updateSearchCondition', {
  //     page: getP._currentPage,
  //     perPage: this.perPageCnt,
  //     params: this.grid.params
  //   });
  //   // 라우트 하기전 실행
  //   next();
  // },
  
  methods: {
    search: function (isKeep) {
      
      this.grid.params = {
        startDt: moment(this.startDate).format('YYYYMMDD'),
        endDt: moment(this.endDate).format('YYYYMMDD'),
        batchId: this.batchId,
        sttusCd: this.sttusCd
      }
      this.$refs.table.search(this.grid.params, isKeep);
      //this.sendStoreData();
    },
    changePerPage: function () { 	// 페이지당 조회할 개수
      this.grid.pagePerRows = this.perPageCnt;
      this.search(true);
    },
    sendStoreData: function () {
      const getP = this.$refs.table.getPagination();
      this.$store.commit('searchcondition/updateSearchCondition', {
        page: getP._currentPage,
        perPage: this.perPageCnt,
        params: this.grid.params
      });
      const getCondition = this.$store.getters['searchcondition/getSearchCondition'];
    },

    //상태코드 리스트 조회
    setCodeData() {
      // 상태 옵션 셋팅.
      api.commCode({'grpCd': 'BTEXE_STTUS_CD'}).then(response => {
        this.statType = response.data.data.list;
      });
    },


    customFormatter: function (date) {
      if (this.sDateDiv == 'month') {
        return moment(date).format('YYYY-MM');
      } else if (this.sDateDiv == 'year') {
        return moment(date).format('YYYY');
      } else {
        return moment(date).format('YYYY-MM-DD');
      }
    },
    initSetStartDate() {
      let setYear = Number(moment(new Date()).format('YYYY'));
      let initStartDate = new Date(setYear, 0, 1);
      this.startDate = initStartDate;
    },
    setPeriodDay(day) {
      this.periodDay = day;
      this.endDate = new Date();
      this.initSetStartDate();

      this.closeDate('start');
      this.closeDate('end');
    },
    selectedStartDate(day) {
      if (day != undefined && day != null) {
        this.periodDay = day;
      }
      if (this.startDate > this.endDate) {
        this.startDate = this.endDate;
      }
    },
    selectedEndDate(day) {
      if (day != undefined && day != null) {
        this.periodDay = day;
      }
    },
    closeDate(type) {
      if (type != undefined && type != null) {
          this.disabledSDate = {from: this.endDate};
          this.disabledEDate = {to: this.startDate, from: new Date()};
      }
    },

    async runExecuteJob(){
        const params = {
          strDate : this.strDate,
          batchId : this.batchId
        }
        try {
          const response = await sysMgtApi.batchExecuteJob(params);
          
          const result = response.data;
          const batchRslt = result.data.BATCH_RSLT;
          const batchRsltMsg = result.data.BATCH_RSLT_MSG;
          
          const succ = 'S';
          const fail = 'F';

          if(batchRslt == succ){
            alert("결과 : 성공 \n"+"결과 메시지 : "+batchRsltMsg);
            this.search();
          } else if (batchRslt == fail){
            alert("결과 : 실패 \n"+"결과 메시지 : "+batchRsltMsg);
            this.search();
          }
        } catch (error) {
        }
    }

  },
  
};
</script>